import pytest

import numpy as np
import scipy.spatial

import dtgw.dtw


def test_dtw_1():
	a = np.array([0, 0, 1, 1, 2, 4, 2, 1, 2, 0])[:,np.newaxis]
	b = np.array([1, 1, 1, 2, 2, 2, 2, 3, 2, 0])[:,np.newaxis]
	matrix = scipy.spatial.distance.cdist(a, b)
	cost, path = dtgw.dtw.dynamic_timewarping(matrix)
	assert path == [(0, 0), (1, 1), (2, 2), (3, 2), (4, 3), (4, 4), (4, 5), (4, 6), (5, 7), (6, 8), (7, 8), (8, 8), (9, 9)]
	assert cost == 4
